(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react')) :
  typeof define === 'function' && define.amd ? define(['react'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, global.useQueueState = factory(global.React));
}(this, (function (react) { 'use strict';

  function useQueueState(initialList) {
      const [list, setList] = react.useState([...initialList]);
      const length = list.length;
      function enqueue(item) {
          const newList = [...list, item];
          setList(newList);
          return newList.length;
      }
      function dequeue() {
          if (list.length > 0) {
              const firstItem = list[0];
              setList([...list.slice(1)]);
              return firstItem;
          }
          return undefined;
      }
      function peek() {
          if (length > 0) {
              return list[0];
          }
          return undefined;
      }
      const controls = {
          enqueue,
          dequeue,
          length,
          peek
      };
      return [list, controls];
  }

  return useQueueState;

})));
//# sourceMappingURL=index.js.map
